﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public enum PE_Grav {
	none, constant, planetary
}

public class PH_Engine : MonoBehaviour {

	public static List<PH_Obj> phos;
	public Vector3 grav = new Vector3(0,-9.8f,0);

	// Use this for initialization
	void Awake () {
		phos = new List<PH_Obj> ();
	}
	
	// Update is called once per frame
	void FixedUpdate () {
		float dt = Time.deltaTime;
		foreach(PH_Obj pho in phos){
			Vector3	acc = pho.acc;
			if(pho.grav == PE_Grav.constant){
				acc += grav;
			}
			Vector3 vel = pho.vel + acc*dt;
			pho.vel = vel;
			pho.posF = pho.pos0;
			pho.pos0 = pho.transform.position;
			pho.pos1 = pho.pos0+vel*dt;
		}
	}
}
