using UnityEngine;
using System.Collections;

public class PH_Obj : MonoBehaviour {
	
	public Vector3 acc = Vector3.zero;
	public Vector3 vel = Vector3.zero;
	public Vector3 posF = Vector3.zero;
	public Vector3 pos0 = Vector3.zero;
	public Vector3 pos1 = Vector3.zero;
	public PE_Grav grav = PE_Grav.constant;
	public bool sideCollide = false;

	// Use this for initialization
	void Start () {
		pos0 = this.transform.position;
		pos1 = pos0;
		PH_Engine.phos.Add (this);
	}

	void FixedUpdate(){
		this.transform.position = pos1;
	}
	
	void OnTriggerEnter(Collider coll){
		Player pla = this.GetComponent<Player> ();
		float newPos = 0f;
		if(coll.gameObject.tag == "SkySprite"){
			return;
		}
		if (this.gameObject.tag == "Strike" || this.gameObject.tag == "Item") {
			return;
		}
		if ((coll.gameObject.tag == "Background" || coll.gameObject.tag == "Strike"|| coll.gameObject.tag == "HarmfulStationary" || coll.gameObject.tag == "BackPlatform" || coll.gameObject.tag == "ItemContain")) {
			float plaLF = posF.x-this.transform.lossyScale.x/2;
			float plaRF = posF.x+this.transform.lossyScale.x/2;
			float plaTF = posF.y+this.transform.lossyScale.y/2;
			float plaBF = posF.y-this.transform.lossyScale.y/2;
			float plaL0 = pos0.x-this.transform.lossyScale.x/2;
			float plaR0 = pos0.x+this.transform.lossyScale.x/2;
			float plaT0 = pos0.y+this.transform.lossyScale.y/2;
			float plaB0 = pos0.y-this.transform.lossyScale.y/2;
			float plaL1 = pos1.x-this.transform.lossyScale.x/2;
			float plaR1 = pos1.x+this.transform.lossyScale.x/2;
			float plaT1 = pos1.y+this.transform.lossyScale.y/2;
			float plaB1 = pos1.y-this.transform.lossyScale.y/2;
			float boxL = coll.transform.position.x-coll.transform.lossyScale.x/2;
			float boxR = coll.transform.position.x+coll.transform.lossyScale.x/2;
			float boxT = coll.transform.position.y+coll.transform.lossyScale.y/2;
			float boxB = coll.transform.position.y-coll.transform.lossyScale.y/2;
			if(((plaB0 < boxT && plaB0 > boxB)&&(plaB1 < boxT && plaB1 > boxB))&&((plaT0 < boxT && plaT0 > boxB)&&(plaT1 < boxT && plaT1 > boxB))){
				//print ("horr");
				if(plaL1 < boxR && plaR1 > boxR){
					pos1.x =  coll.transform.position.x+((coll.transform.lossyScale.x + this.transform.lossyScale.x) / 2.0f);
					sideCollide = true;
				}
				else if(plaR1 > boxL && plaL1 < boxL){
					pos1.x = coll.transform.position.x-((coll.transform.lossyScale.x + this.transform.lossyScale.x) / 2.0f);
					sideCollide = true;
				}
			}
			else if(this.transform.position.y >= boxB && this.transform.position.y <= boxT){
				if(plaL1 < boxL && plaR1 > boxL){
					pos1.x = coll.transform.position.x-((this.transform.lossyScale.x+coll.transform.lossyScale.x)/2.0f);
					sideCollide = true;
				}
				else if(plaR1 > boxR && plaL1 < boxR){
					pos1.x = coll.transform.position.x+((this.transform.lossyScale.x+coll.transform.lossyScale.x)/2.0f);
					sideCollide = true;
				}
			}
			else if((((plaL0 >= boxL && plaL0 <= boxR)&&(plaL1 >= boxL && plaL1 <= boxR) && (plaLF >= boxL && plaLF <= boxR))&&((plaR0 >= boxL && plaR0 <= boxR)&&(plaR1 >= boxL && plaR1 <= boxR) && (plaRF >= boxL && plaRF <= boxR)))){
				if( plaB0 > coll.transform.position.y){
					if(this.gameObject.tag == "PlayerCont" && !pla.jump){
						newPos = ((coll.transform.lossyScale.y + this.transform.lossyScale.y) / 2.0f)+coll.transform.position.y;
						pos1.y = newPos;
						this.vel.y = 0f;
					}
				}
				else if(plaT0 < coll.transform.position.y){
					newPos = coll.transform.position.y-((coll.transform.lossyScale.y + this.transform.lossyScale.y) / 2.0f)-.0001f;
					pos1.y = newPos;
					this.vel.y = 0f;
					this.acc.y = 0f;
				}
			}
			/*else{
				if(plaB0 < boxB){
					if(plaR0-plaR1 > 0){
						pos1.x = ((coll.transform.lossyScale.x + this.transform.lossyScale.x) / 2.0f)+coll.transform.position.x;
					}
					else{
						pos1.x = newPos = coll.transform.position.x-((coll.transform.lossyScale.x + this.transform.lossyScale.x) / 2.0f);
					}
				}
				else if((boxT > plaB1 && boxT < plaT1) &&(boxT > plaB0 && boxT < plaT0)){
					if(plaR0-plaR1 > 0){
						if(this.transform.position.x > coll.transform.position.x){
							pos1.x = ((coll.transform.lossyScale.x + this.transform.lossyScale.x) / 2.0f)+coll.transform.position.x;
						}
						else{
							pos1.x = coll.transform.position.x-((coll.transform.lossyScale.x + this.transform.lossyScale.x) / 2.0f);
						}
					}
					else{
						pos1.x = coll.transform.position.x-((coll.transform.lossyScale.x + this.transform.lossyScale.x) / 2.0f);
					}
				}

				else{
					if(Mathf.Abs(plaR1 - boxL) > Mathf.Abs(plaT1 - boxT)){
						pos1.y = ((coll.transform.lossyScale.y + this.transform.lossyScale.y) / 2.0f)+coll.transform.position.y;
						this.vel.y = 0f;
					}
					else{
						if(plaR0-plaR1 > 0){
							pos1.x = ((coll.transform.lossyScale.x + this.transform.lossyScale.x) / 2.0f)+coll.transform.position.x;
						}
						else{
							pos1.x = newPos = coll.transform.position.x-((coll.transform.lossyScale.x + this.transform.lossyScale.x) / 2.0f);
						}
					}
				}
			}*/
			else{
				if(plaT1 >= boxT && plaB1 <= boxB){
					if(this.transform.position.x <= boxL){
						pos1.x = coll.transform.position.x-((this.transform.lossyScale.x+coll.transform.lossyScale.x)/2.0f);
						sideCollide = true;
					}
					else if(this.transform.position.x >= boxR){
						pos1.x = coll.transform.position.x+((this.transform.lossyScale.x+coll.transform.lossyScale.x)/2.0f);
						sideCollide = true;
					}
				}
				else if(plaB1 <= boxT && plaT1 >= boxT && !((plaT1 > boxT)&&(plaB1 < boxB))){
					if(this.transform.position.y >= boxT && (this.transform.position.x >= boxL && this.transform.position.x <= boxR)){
						pos1.y = coll.transform.position.y+((coll.transform.lossyScale.y+this.transform.lossyScale.y)/2.0f);
						this.vel.y = 0f;
					}
					else if((plaBF >= boxT || plaB0 >= boxT) && ((plaRF >= boxL && plaRF <= boxR) || (plaLF >= boxL && plaLF <= boxR))){
						pos1.y = coll.transform.position.y+((coll.transform.lossyScale.y+this.transform.lossyScale.y)/2.0f);
						this.vel.y = 0f;
					}
					else if((plaR1 > boxL && plaL1 < boxL)){
						pos1.x = coll.transform.position.x-((coll.transform.lossyScale.x+this.transform.lossyScale.x)/2.0f);
						sideCollide = true;
					}
					else if((plaL1 < boxR && plaR1 > boxR)){
						pos1.x = coll.transform.position.x+((coll.transform.lossyScale.x+this.transform.lossyScale.x)/2.0f);
						sideCollide = true;
					}
					/*if(plaR1 - boxL > 0){
						if(Mathf.Abs(plaB1-plaB0) > Mathf.Abs(plaR1-plaR0)){
							pos1.x = coll.transform.position.x-(coll.transform.lossyScale.x/2.0f);
						}
						else{
							pos1.y = coll.transform.position.y+((coll.transform.lossyScale.y+this.transform.lossyScale.y)/2.0f);
							this.vel.y = 0f;
						}
					}
					else if(boxR - plaL1 > 0){
						if(Mathf.Abs(plaB1-plaB0) > Mathf.Abs(plaL1 - plaL0)){
							pos1.x = coll.transform.position.x+(coll.transform.lossyScale.x/2.0f);
						}
						else{
							pos1.y = coll.transform.position.y+((coll.transform.lossyScale.y+this.transform.lossyScale.y)/2.0f);
							this.vel.y = 0f;
						}
					}
					else{
						pos1.y = coll.transform.position.y+((coll.transform.lossyScale.y+this.transform.lossyScale.y)/2.0f);
						this.vel.y = 0f;
					}*/
				}
				else if(plaT1 >= boxB && plaB1 <= boxB && !((plaT1 > boxT)&&(plaB1 < boxB))){
					if(plaT0 <= boxB && ((plaL1 <= boxR && plaL1 >= boxL) || (plaR1 >= boxL && plaR1 <= boxR))){
						pos1.y = coll.transform.position.y-((coll.transform.lossyScale.y+this.transform.lossyScale.y)/2.0f);
						this.vel.y = 0f;
					}
					else if(plaR1 > boxL && plaL1 < boxL && this.vel.y < 0){
						pos1.y = coll.transform.position.y-((coll.transform.lossyScale.y+this.transform.lossyScale.y)/2.0f);
						this.vel.y = 0f;
						this.acc.y = 0f;
					}
					else if(plaR1 > boxL && plaL1 < boxL && (this.vel.y >= 0 || (plaTF >= boxB && plaTF <= boxT)) ){
						pos1.x = coll.transform.position.x-((coll.transform.lossyScale.x+this.transform.lossyScale.x)/2.0f);
						this.vel.x = 0f;
						sideCollide = true;
					}
					else if(plaL1 < boxR && plaR1 > boxR && this.vel.y < 0){
						pos1.y = coll.transform.position.y-((coll.transform.lossyScale.y+this.transform.lossyScale.y)/2.0f);
						this.vel.y = 0f;
						this.acc.y = 0f;
					}
					else if(plaL1 < boxR && plaR1 > boxR && (this.vel.y >= 0 || (plaTF >= boxB && plaTF <= boxT))){
						pos1.x = coll.transform.position.x+((coll.transform.lossyScale.x+this.transform.lossyScale.x)/2.0f);
						this.vel.x = 0f;
						sideCollide = true;
					}
				}
				else if(Mathf.Abs(this.transform.position.x - coll.transform.position.x) < (this.transform.lossyScale.x+coll.transform.lossyScale.x)/2f && !(this.transform.position.y > coll.transform.position.y+(coll.transform.lossyScale.y/2f) || this.transform.position.y < coll.transform.position.y-(coll.transform.lossyScale.y/2f))){
					if(this.transform.position.x - coll.transform.position.x < 0){
						pos1.x = coll.transform.position.x-((coll.transform.lossyScale.x+this.transform.lossyScale.x)/2f);
					}
					else{
						pos1.x = coll.transform.position.x+((coll.transform.lossyScale.x+this.transform.lossyScale.x)/2f);
					}
				}
				}
			}
			if(this.tag == "PlayerCont"){
				Player them = this.GetComponent<Player>();
				them.pogoFun(coll);
			}
	}

	void OnTriggerExit(Collider coll){
		sideCollide = false;
	}

	void OnTriggerStay(Collider coll){
		OnTriggerEnter (coll);
	}

	public void trig(Collider coll){
		OnTriggerEnter (coll);
	}

	void OnDestroy(){
		PH_Obj pho = this.GetComponent<PH_Obj> ();
		PH_Engine.phos.Remove (pho);
		Destroy (this.gameObject);
	}
}
