﻿using UnityEngine;
using System.Collections;
using UnityEngine.UI;

public class Player : MonoBehaviour {

	public float speed = 5f;
	public float jumpSpeed = 3f;
	public float jumpStartSpeed = 10f;
	public bool jump = false;
	public int maxJumpFrames = 50;
	public int jumpFrames = 0;
	public bool pogo = false;
	public float maxPogoFrames = 40;
	public float pogoFrames;
	public int lives = 3;
	public Text liveCount;
	public Text scoreCount;
	public Text healthCount;
	public int score = 0;
	public bool climbing = false;
	public float climbx = 0f;
	public Vector3 spawn = Vector3.zero;
	public int health = 3;
	public int maxInv = 25;
	public int inv = 0;
	public int spawnLevel = 1;
	public float jumpPos = 20f;
	public bool GMode = false;
	public int coinInv = 0;
	public int charge = 0;
	public int chargeFrames = 0;
	public int maxChargeFrames = 50;
	public int recharge = 0;
	public int rechargetime = 10;
	public Material pogoLeft;
	public Material pogoRight;
	public Material left;
	public Material right;
	public string currLevel;
	public int dir = 0;
	public float platformSpd = 0;

	// Use this for initialization
	void Start () {
		GameObject temp = GameObject.Find ("Lives");
		liveCount = temp.GetComponent<Text> ();
		GameObject temp2 = GameObject.Find ("Score");
		scoreCount = temp2.GetComponent<Text> ();
		GameObject temp3 = GameObject.Find ("Health");
		healthCount = temp3.GetComponent<Text> ();
	}

	void Update(){
		PH_Obj pho = this.GetComponent<PH_Obj> ();
		/*if(pho.vel.y == 0){
			pogo = false;
		}*/
		if(Input.GetKeyDown(KeyCode.G)){
			GMode = !GMode;
		}
		if(GMode){
			inv = maxInv;
		}
		if((Input.GetKey (KeyCode.X) || Input.GetKey(KeyCode.Period)) && (Input.GetKey(KeyCode.S) || Input.GetKey(KeyCode.DownArrow)) && pho.vel.y != 0){
			pogo = true;
		}
		if (pho.vel.y <= 0) {
			jumpFrames = -1;
			jump = false;
			pogoFrames = -1;
		}
		if ((Input.GetKeyDown (KeyCode.Z) || Input.GetKeyDown(KeyCode.Comma)) && pho.vel.y == 0 && !jump && !climbing) {
			pho.acc.y =  jumpSpeed;
			jumpFrames = maxJumpFrames;
			jump = true;
			pho.vel.y = jumpStartSpeed;
		}
		if ((Input.GetKeyUp (KeyCode.Z) || Input.GetKeyUp(KeyCode.Comma)) && jumpFrames > 0) {
			jumpFrames = 0;
			pho.acc.y = 0f;
			pho.vel.y = 0f;
		}
		if (Input.GetKeyUp (KeyCode.X) || Input.GetKeyUp(KeyCode.Period)) {
			pogo = false;
			if(dir == -1){
				this.renderer.material = left;
			}
			else if(dir == 1){
				this.renderer.material = right;
			}
			if(pogoFrames > 0){
				pho.vel.y = 0f;
				pho.acc.y = 0f;
				pogoFrames = 0;
			}
		}
		if((Input.GetKey(KeyCode.D) || Input.GetKey(KeyCode.RightArrow)) && !(Input.GetKey(KeyCode.A) || Input.GetKey(KeyCode.LeftArrow))){
			pho.vel.x = speed;
			this.renderer.material = right;
			dir = 1;
			/*if(pogo){
				this.renderer.material = pogoRight;
			}*/
		}
		else if((Input.GetKey(KeyCode.A) || Input.GetKey(KeyCode.LeftArrow)) && !(Input.GetKey(KeyCode.D) || Input.GetKey(KeyCode.RightArrow))){
			pho.vel.x = -speed;
			this.renderer.material = left;
			dir = -1;
			/*if(pogo){
				this.renderer.material = pogoLeft;
			}*/
		}
		else{
			pho.vel.x = 0f;
		}
		pho.vel.x += platformSpd;
		if(pogo){
			if(dir == -1){
				this.renderer.material = pogoLeft;
			}
			else if(dir == 1){
				this.renderer.material = pogoRight;
			}
		}
		else if(!pogo){
			if(dir == -1){
				this.renderer.material = left;
			}
			else if(dir == 1){
				this.renderer.material = right;
			}
		}
		if((Input.GetKey(KeyCode.X) || Input.GetKey(KeyCode.Period)) && (Input.GetKey(KeyCode.LeftArrow) || Input.GetKey(KeyCode.A)) && charge == 0 && recharge == 0 && !pogo){
			charge = -1;
			chargeFrames = maxChargeFrames;
		}
		else if((Input.GetKey(KeyCode.X) || Input.GetKey(KeyCode.Period)) && (Input.GetKey(KeyCode.RightArrow) || Input.GetKey(KeyCode.D)) && charge == 0 && recharge == 0 && !pogo){
			charge = 1;
			chargeFrames = maxChargeFrames;
		}
		if(charge == -1 && !(Input.GetKey(KeyCode.LeftArrow) || Input.GetKey(KeyCode.A)) && !(Input.GetKey(KeyCode.RightArrow) || Input.GetKey(KeyCode.D)) && recharge == 0){
			charge = 0;
			chargeFrames = 0;
		}
		else if(charge == 1 && !(Input.GetKey(KeyCode.LeftArrow) || Input.GetKey(KeyCode.A)) && !(Input.GetKey(KeyCode.RightArrow) || Input.GetKey(KeyCode.D)) && recharge == 0){
			charge = 0;
			chargeFrames = 0;
		}
		else if(charge != 0 && !(Input.GetKey(KeyCode.X) || Input.GetKey(KeyCode.Period)) && recharge == 0){
			charge = 0;
			chargeFrames = 0;
		}
		if(chargeFrames > 0){
			pho.vel.x = speed*3f*charge;
			pho.vel.y = 0;
			pho.acc.y = 300f;
		}
		else if(chargeFrames == 0){
			pho.acc.y = 0f;
			pho.vel.y = 0;
			chargeFrames--;
			recharge = rechargetime;
		}
		liveCount.text = "P: ";
		liveCount.text += lives.ToString ();
		scoreCount.text = "Score: ";
		scoreCount.text += score.ToString ();
		healthCount.text = "Health: ";
		healthCount.text += health.ToString ();
		if (pho.sideCollide && pho.vel.y == 0 && Input.GetKeyDown(KeyCode.X)) {
			Vector3 sphereC = new Vector3((this.transform.position.x+((this.transform.lossyScale.x/2.0f))*(pho.vel.x/speed)), this.transform.position.y, this.transform.position.z);
			Collider[] colls = Physics.OverlapSphere(sphereC, 5f);
			int collNum = 0;
			foreach(Collider colli in colls){
				if(colli.gameObject.tag == "Strike"){
					collNum++;
				}
			}
			if(collNum == 1){
				foreach(Collider colli in colls){
					if(colli.gameObject.tag == "Strike"){
						StoneStrike swing = colli.GetComponent<StoneStrike>();
						swing.Swing(this.gameObject);
						break;
					}
				}
			}
			else if(collNum == 2){
				Collider top = colls[0];
				foreach(Collider colli in colls){
					if(colli.gameObject.tag == "Strike" && top.gameObject.tag != "Strike"){
						top = colli;
					}
					else if(colli.gameObject.tag == "Strike" && top.gameObject.tag == "Strike"){
						if(colli.transform.position.y > top.transform.position.y){
							top = colli;
						}
					}
				}
				StoneStrike swing = top.GetComponent<StoneStrike>();
				swing.Swing(this.gameObject);
			}
		}
		if (climbing) {
			pho.vel.x = 0;
			if(Input.GetKey (KeyCode.W) || Input.GetKey(KeyCode.UpArrow)){
				pho.pos0.x = climbx;
				pho.pos1.x = climbx;
				pho.vel.y = 50f;
				pho.acc.y = 300f;
			}
			else if(Input.GetKey(KeyCode.S) || Input.GetKey(KeyCode.DownArrow)){
				pho.pos0.x = climbx;
				pho.pos1.x = climbx;
				pho.vel.y = -50f;
				pho.acc.y = 300f;
			}
			else{
				pho.pos0.x = climbx;
				pho.pos1.x = climbx;
				pho.vel.y = 0f;
				pho.acc.y = 300f;
			}
			if (Input.GetKeyDown (KeyCode.Z) || Input.GetKey(KeyCode.Comma)) {
				climbing = false;
				pho.acc.y = 0f;
			}
		}
	}

	// Update is called once per frame
	void FixedUpdate () {
		PH_Obj pho = this.GetComponent<PH_Obj> ();
		if (jumpFrames > 0) {
			pho.acc.y = jumpSpeed;
			jumpFrames--;
		}
		else if(jumpFrames == 0){
			pho.acc.y = 0f;
			jumpFrames = -1;
		}
		if(pogoFrames > 0){
			pho.vel.y = jumpStartSpeed;
			pho.acc.y = jumpSpeed;
			pogoFrames--;
		}
		else if (pogoFrames == 0) {
			pho.acc.y = 0f;
			pogoFrames = -1;
		}
		if(inv % 2 > 0){
			this.renderer.enabled = !this.renderer.enabled;
		}
		if (inv > 0) {
			inv--;
		}
		else if(inv == 0){
			this.renderer.enabled = true;
		}
		if(coinInv % 2 > 0){
			this.renderer.enabled = !this.renderer.enabled;
		}
		if(coinInv > 0){
			coinInv--;
		}
		else if(coinInv == 0){
			this.renderer.enabled = true;
		}
		if(chargeFrames > 0){
			chargeFrames--;
		}
		if(recharge > 0){
			--recharge;
		}
	}

	public void pogoFun(Collider coll){
		PH_Obj pho = this.GetComponent<PH_Obj> ();
		if(coll.gameObject.tag == "Climb"){
			return;
		}
		if (pogo && this.transform.position.x >= coll.transform.position.x - (coll.transform.lossyScale.x / 2.0f) && this.transform.position.x <= coll.transform.position.x + (coll.transform.lossyScale.x / 2.0f) && this.transform.position.y >= coll.transform.position.y+(coll.transform.lossyScale.y/2.0f)) {
			if (coll.gameObject.tag == "Strike") {
				StoneStrike stone = coll.GetComponent<StoneStrike>();
				stone.pogo();
			}
			if (coll.gameObject.tag == "Harmful") {
				SquidManager squid = coll.GetComponent<SquidManager>();
				squid.pogo();
			}
			if(coll.gameObject.tag == "ItemContain"){
				ChestManager chest = coll.GetComponent<ChestManager>();
				chest.pogo();
			}
			if(coll.gameObject.tag == "CamTrig" || coll.gameObject.tag == "Item"){
				return;
			}
			pogoFrames = maxPogoFrames;
			pho.vel.y = jumpStartSpeed;
			pho.acc.y = jumpSpeed;
			pho.pos1.y += .5f;
		}
		if(chargeFrames > 0 && this.transform.position.y >= coll.transform.position.y -(coll.transform.lossyScale.y/2f) && this.transform.position.y <= coll.transform.position.y + (coll.transform.lossyScale.y/2f)){
			if(coll.gameObject.tag == "Strike"){
				StoneStrike stone = coll.GetComponent<StoneStrike>();
				stone.Swing(this.gameObject);
			}
			if(coll.gameObject.tag == "ItemContain"){
				ChestManager chest = coll.GetComponent<ChestManager>();
				chest.Swing();
			}
			if(coll.gameObject.tag == "Harmful"){
				SquidManager squid = coll.GetComponent<SquidManager>();
				squid.pogo ();
			}
		}
		if(chargeFrames > 0){
			if(!pho.sideCollide || coll.transform.position.y < this.transform.position.y-(this.transform.lossyScale.y/2f)){
				return;
			}
			if(charge == -1 && coll.transform.position.x < this.transform.position.x){
				chargeFrames = 0;
				pho.vel.x = 0;
				pho.pos1.x = coll.transform.position.x+((coll.transform.lossyScale.x+this.transform.lossyScale.x)/2f);
			}
			else if(charge == 1 && coll.transform.position.x > this.transform.position.x){
				chargeFrames = 0;
				pho.vel.x = 0;
				pho.pos1.x = coll.transform.position.x-((coll.transform.lossyScale.x+this.transform.lossyScale.x)/2f);
			}
		}
		if(coll.gameObject.tag == "Background" || coll.gameObject.tag == "Harmful"){
			return;
		}
		if(Mathf.Abs(this.transform.position.x - coll.transform.position.x) < (coll.transform.lossyScale.x+this.transform.lossyScale.x)/2f && coll.transform.position.y > this.transform.position.y-(this.transform.lossyScale.y/2f)){
			if(this.transform.position.x - coll.transform.position.x < 0){
				pho.pos1.x = coll.transform.position.x-((coll.transform.lossyScale.x+this.transform.lossyScale.x)/2f);
			}
			else{
				pho.pos1.x = coll.transform.position.x+((coll.transform.lossyScale.x+this.transform.lossyScale.x)/2f);
			}
		}
		else if (pogo && pogoFrames <= 0 && this.transform.position.y >= coll.transform.position.y+(coll.transform.lossyScale.y/2.0f)){
			pogoFrames = 0;
			pogo = false;
		}
	}

	void OnTriggerEnter(Collider coll){
		PH_Obj pho = this.GetComponent<PH_Obj>();
		if (coll.gameObject.tag == "Climb") {
			if(climbing == false && (Input.GetKey(KeyCode.W) || Input.GetKey(KeyCode.UpArrow))){
				climbing = true;
				climbx = coll.transform.position.x;
			}
		}
		pho.trig (coll);
		if((coll.gameObject.tag == "Harmful" || coll.gameObject.tag =="HarmfulStationary") && inv == 0 && coinInv == 0){
			float boxL = coll.transform.position.x-coll.transform.lossyScale.x/2;
			float boxR = coll.transform.position.x+coll.transform.lossyScale.x/2;
			float boxT = coll.transform.position.y+coll.transform.lossyScale.y/2;
			float boxB = coll.transform.position.y-coll.transform.lossyScale.y/2;
			if(pogo && this.transform.position.y > boxT && (this.transform.position.x >= boxL && this.transform.position.x <= boxR)){
				return;
			}
			if(chargeFrames > 0 && this.transform.position.y <= boxT && this.transform.position.y >= boxB){
				return;
			}
			/*float plaT = this.transform.position.y+this.transform.lossyScale.y/2;
			float plaB = this.transform.position.y-this.transform.lossyScale.y/2;
			float plaL = this.transform.position.x-this.transform.lossyScale.x/2;
			float plaR = this.transform.position.x+this.transform.lossyScale.x/2;
			PH_Obj pho = this.GetComponent<PH_Obj>();
			health--;
			if(health == 0){
				Respawn();
			}
			inv = maxInv;
			if((plaT > boxB && plaT < boxT) && (this.transform.position.x > boxL && this.transform.position.x < boxR)){
				pho.acc.y = 0;
				pho.vel.y = 0;
			}
			else if((plaB > boxB && plaB < boxT) && (this.transform.position.x > boxL && this.transform.position.x < boxR)){
				pho.acc.y = 0;
				pho.vel.y = 0;
			}
			else if((plaR > boxL && plaR < boxR) && (this.transform.position.y > boxB && this.transform.position.y < boxT)){
				pho.acc.y = 0;
				pho.vel.y = 30;
				pho.vel.x = -30;
			}
			else if((plaL > boxL && plaR < boxR) && (this.transform.position.y > boxB && this.transform.position.y < boxT)){
				pho.acc.y = 0;
				pho.vel.y = 30;
				pho.vel.x = 30;
			}
			if(inv > 0 && (this.transform.position.x > boxL && this.transform.position.x < boxR)){
				pho.vel.y = 0;
				pho.pos1.y = coll.transform.position.y+((coll.transform.lossyScale.y+this.transform.lossyScale.y)/2.0f);
			}*/

			if(inv == 0 && (this.transform.position.x >= boxL && this.transform.position.x <= boxR) || (this.transform.position.y >= boxB && this.transform.position.y <= boxT)){
				if(this.transform.position.x < coll.transform.position.x){
					pho.pos1.x -= jumpPos;
				}
				else{
					pho.pos1.x += jumpPos;
				}
				inv = maxInv;
				health--;
				if(health == 0){
					Respawn();
				}
			}
		}
		if(coinInv > 0){
			if(coll.gameObject.tag == "Harmful"){
				SquidManager temp = coll.GetComponent<SquidManager>();
				temp.pogo ();
			}
		}
	}

	/*public void Damage(Collider coll){
		if (inv > 0) {
			return;
		}
		float boxL = coll.transform.position.x-coll.transform.lossyScale.x/2;
		float boxR = coll.transform.position.x+coll.transform.lossyScale.x/2;
		float boxT = coll.transform.position.y+coll.transform.lossyScale.y/2;
		float boxB = coll.transform.position.y-coll.transform.lossyScale.y/2;
		float plaT = this.transform.position.y+this.transform.lossyScale.y/2;
		float plaB = this.transform.position.y-this.transform.lossyScale.y/2;
		float plaL = this.transform.position.x-this.transform.lossyScale.x/2;
		float plaR = this.transform.position.x+this.transform.lossyScale.x/2;
		PH_Obj pho = this.GetComponent<PH_Obj>();
		health--;
		if(health == 0){
			Respawn();
		}
		inv = maxInv;
		if((plaT > boxB && plaT < boxT) && (this.transform.position.x > boxL && this.transform.position.x < boxR)){
			pho.acc.y = 0;
			pho.vel.y = -10;
			jumpFrames = -1;
			pogoFrames = -1;
		}
		else if((plaB > boxB && plaB < boxT) && (this.transform.position.x > boxL && this.transform.position.x < boxR)){
			pho.acc.y = 0;
			pho.vel.y = 30;
			jumpFrames = -1;
			pogoFrames = -1;
		}
		else if((plaR > boxL && plaR < boxR) && (this.transform.position.y > boxB && this.transform.position.y < boxT)){
			pho.acc.y = 0;
			pho.vel.y = 30;
			pho.vel.x = -30;
			jumpFrames = -1;
			pogoFrames = -1;
		}
		else if((plaL > boxL && plaL < boxR) && (this.transform.position.y > boxB && this.transform.position.y < boxT)){
			pho.acc.y = 0;
			pho.vel.y = 30;
			pho.vel.x = 30;
			jumpFrames = -1;
			pogoFrames = -1;
		}
		if(inv > 0 && (this.transform.position.x > boxL && this.transform.position.x < boxR)){
			pho.vel.y = 0;

		}
	}*/
		
	void OnTriggerStay(Collider coll){
		OnTriggerEnter (coll);
	}

	void OnTriggerExit(Collider coll){
		if (coll.gameObject.tag == "Climb") {
			climbing = false;
		}
	}

	public void Respawn(){
		PH_Obj pho = this.GetComponent<PH_Obj> ();
		pho.pos0 = spawn;
		pho.pos1 = spawn;
		this.transform.position = spawn;
		if (lives == 0) {
			Application.LoadLevel(currLevel);
		}
		lives--;
		health = 3;
		CameraMove tmp = GameObject.Find ("Main Camera").GetComponent<CameraMove> ();
		tmp.level = spawnLevel;
		TimeScript tim = GameObject.Find ("Time").GetComponent<TimeScript> ();
		tim.time = tim.maxtime;
	}
}
