﻿using UnityEngine;
using System.Collections;

public class SquidManager : MonoBehaviour {
	public float topleft = 100f;
	public float bottomright = 0f;
	public float speed = 30f;
	public bool turn = true;
	public Camera cam;
	public float camW;
	public float camH;
	public bool vert = true;

	// Use this for initialization
	void Start () {
		cam = GameObject.Find ("Main Camera").GetComponent<Camera> ();
		camH = cam.orthographicSize * 2f;
		camW = camH * cam.aspect;
	}

	void FixedUpdate(){
		Vector3 now = this.transform.position;
		if(now.x < cam.transform.position.x - camW/2f || now.x > cam.transform.position.x + camW/2f || now.y < cam.transform.position.y - camH/2f || now.y > cam.transform.position.y + camH/2f){
			this.GetComponent<MeshRenderer> ().enabled = true;
			this.GetComponent<Collider> ().enabled = true;
		}
	}

	// Update is called once per frame
	void Update () {
		if(vert){
			if (turn && (this.transform.position.y >= topleft || this.transform.position.y <= bottomright)) {
				speed *= -1;
				turn = false;
			}
			if (this.transform.position.y < topleft && this.transform.position.y > bottomright) {
				turn = true;
			}
			PH_Obj pho = this.GetComponent<PH_Obj> ();
			pho.vel.y = speed;
		}
		else{
			if (turn && (this.transform.position.x <= topleft || this.transform.position.x >= bottomright)) {
				speed *= -1;
				turn = false;
			}
			if (this.transform.position.x > topleft && this.transform.position.x < bottomright) {
				turn = true;
			}
			PH_Obj pho = this.GetComponent<PH_Obj> ();
			pho.vel.x = speed;
		}
	}

	public void pogo(){
		this.GetComponent<MeshRenderer> ().enabled = false;
		this.GetComponent<Collider> ().enabled = false;
	}

	void OnTriggerEnter(Collider coll){
		if(coll.gameObject.tag == "Strike"){
			coll.renderer.enabled = false;
			coll.collider.enabled = false;
			pogo ();
		}
	}
}
