﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class StoneStrike : MonoBehaviour {
	public bool launch = false;
	public Vector3 spawn = Vector3.zero;
	public Camera cam;
	public float camW;
	public float camH;
	public int invis = 0;
	public int maxInvis = 10;

	// Use this for initialzation
	void Start () {
		spawn = this.transform.position;
		cam = GameObject.Find ("Main Camera").GetComponent<Camera> ();
		camH = cam.orthographicSize * 2f;
		camW = camH * cam.aspect;
	}
	
	// Update is called once per frame
	void Update () {
		Vector3 now = this.transform.position;
		if(launch) return;
		if(now.x < cam.transform.position.x - camW/2f || now.x > cam.transform.position.x + camW/2f || now.y < cam.transform.position.y - camH/2f || now.y > cam.transform.position.y + camH/2f){
			this.GetComponent<MeshRenderer> ().enabled = true;
			this.GetComponent<Collider> ().enabled = true;
		}
	}

	void FixedUpdate(){
		if (invis == 0) {
			launch = false;
			Vector3 now = this.transform.position;
			if(now.x < cam.transform.position.x - camW/2f || now.x > cam.transform.position.x + camW/2f || now.y < cam.transform.position.y - camH/2f || now.y > cam.transform.position.y + camH/2f){
				this.renderer.enabled = true;
				this.collider.enabled = true;
			}
			return;
		}
		invis--;
	}

	public void Swing(GameObject gam){
		PH_Obj pho = this.GetComponent<PH_Obj> ();
		pho.vel.x = 50;
		if (this.transform.position.x - gam.transform.position.x < 0) {
			pho.vel.x *= -1;
		}
		pho.vel.y = 50;
		launch = true;
	}

	public void pogo(){
		this.renderer.enabled = false;
		this.collider.enabled = false;
	}

	/*void OnTriggerEnter(Collider coll){
		if (launch) {
			this.renderer.enabled = false;
			this.collider.enabled = false;
		}
	}

	void OnTriggerStay(Collider coll){
		OnTriggerEnter (coll);
	}*/

	void OnBecameInvisible(){
		this.transform.position = spawn;
		PH_Obj pho = this.GetComponent<PH_Obj> ();
		pho.pos0 = spawn;
		pho.pos1 = spawn;
		pho.vel.y = 0f;
		pho.vel.x = 0f;
		invis = maxInvis;
		this.renderer.enabled = false;
		this.collider.enabled = false;
	}
	
}
